;Nummersender for brann og innbrudsalarm
;Sender varsel til 2 stk. telefoner ( tilfeldige telefonnummer)
;Pulserende tone for innbrudd og vekslende tone for brannalarm
;Senderen sender ikke nytt varsel frinngangen har vrt lav i min.10sek.
;Etter 5 varsel lses senderen og summeren gir fra seg en pulserende tone.
;Da m senderen resettes fr nye varsel kan gis
;Nummersenderen og programvaren er utviklet av Sondre Danielsen.

	LIST    P=16C84;f=inhx8m
	
_CP_OFF		equ	H'3FFF'			;code protect off
_PWRTE_ON	equ	H'3FFF' 		;Power on timer on
_WDT_OFF	equ	H'3FFB'			;watch dog timer off
_XT_OSC		equ	H'3FFD'			;crystal oscillator
__CONFIG       _CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC

teller	equ	1A	
inng	equ	0F
xx	equ	0E	
same	equ	1
count1  equ     0C      ; wait counter ls digit file register C
count2  equ	0D	; wait counter ms digit file register D
porta   equ     05      ; port b I/O register f6
portb	equ	06	; port a I/O register f5
trisa	equ	085h
status	equ	03h
;
;
init   
	clrf	porta
	bsf	status,5
	movlw	B'00011'	;setter porta,01 til inng.og 234 til utg.
	movwf	trisa
	bcf	status,5
	movlw   0
	                  	; set porta as outputs
	                 	; set porta levels all low
	tris    portb           ; set portb as outputs
	movwf   portb           ; set portb levels all low
	movlw   0		;flytt 0 inn i buffer w
	movwf   xx		;Sett xx=w
	movlw	5		;hvor mange ganger et varsel kan gis 
	movwf	teller		;fr senderen lses,starter ogs summer
	
				;porta,0=Brann
				;porta,1=Tyveri

	
	

start

	clrf	inng		;inng er et register som husker hvilken 
	clrf	portb		;inngang som er aktivert bit 0 og 1.
	btfsc	porta,0		;bit 3 husker at tlf2 er aktivert
	bsf	inng,0
	btfsc	porta,1
	bsf	inng,1
	btfsc	inng,0
	goto	tlf1
	btfsc	inng,1
	goto	tlf1
	goto	start
tlf1	
	bsf	portb,7		;venter p summetone
	movlw	40		;ventetid for 1.summetone
	movwf	xx

;Telefonnummer 
;0=B'10000000'
;1=B'10001000'
;2=B'10000100'
;3=B'10001100'
;4=B'10000010'
;5=B'10001010'
;6=B'10000110'
;7=B'10001110'
;8=B'10000001'
;9=B'10001001'



t
	call	wait		;ringer telefon nr.90780227
	decfsz	xx	
	goto 	t
	movlw	B'10001001'	;9
	movwf	portb
	call 	strobe
	movlw	B'10000000'	;0
	movwf	portb
	call 	strobe
	movlw	B'10001110'	;7
	movwf	portb
	call 	strobe
	movlw	B'10000001'	;8
	movwf	portb
	call 	strobe
	movlw	B'10000000'	;0
	movwf	portb
	call 	strobe
	movlw	B'10000100'	;2
	movwf	portb
	call 	strobe
	movlw	B'10000100'	;2
	movwf	portb
	call 	strobe
	movlw	B'10001110'	;7
	movwf	portb
	call 	strobe
	btfsc	inng,0
	goto	brann
	btfsc	inng,1
	goto	tyveri
	
tlf2	clrf	portb
	movlw	50		;tiden linjen brytes fr 2.oppring
	movwf	xx
o	call	wait
	decfsz	xx
	goto	o
	bsf	portb,7		;venter p summetone
	movlw	40		;ventetid for 2.summetone
	movwf	xx
tt
	call	wait		;ringer telefon nr.92330744
	decfsz	xx	
	goto 	tt
	movlw	B'10001001'	;9
	movwf	portb
	call 	strobe
	movlw	B'10000100'	;2
	movwf	portb
	call 	strobe
	movlw	B'10001100'	;3
	movwf	portb
	call 	strobe
	movlw	B'10001100'	;3
	movwf	portb
	call 	strobe
	movlw	B'10000000'	;0
	movwf	portb
	call 	strobe
	movlw	B'10001110'	;7
	movwf	portb
	call 	strobe
	movlw	B'10000010'	;4
	movwf	portb
	call 	strobe
	movlw	B'10000010'	;4
	movwf	portb
	call 	strobe
	bsf	inng,2
	btfsc	inng,0
	goto	brann
	btfsc	inng,1
	goto	tyveri

brann	bcf	portb,6		;gir brann tone,vekslende tone
	movlw	20		;tid fr tonen begynner
	movwf	xx
a	call	wait
	decfsz	xx
	goto	a	
	movlw	70		;bestemmer hvor lenge signalet varer
	movwf	xx
c
	bcf	portb,6		
	call	wait
	movlw	B'10010000'	;Lav tone
	movwf	portb
	call 	strobe
	call 	wait
	call	wait
	movlw	B'10011001'	;Hy tone
	movwf	portb
	call 	strobe
	call	wait
	call 	wait
	decfsz	xx	
	goto 	c
	btfsc	inng,2
	goto	restart
	goto	tlf2

tyveri	bcf	portb,6		;gir tyveri tone,pulserende tone
	movlw	20		;tid fr tonen begynner
	movwf	xx
e	call	wait
	decfsz	xx
	goto	e	
	movlw	100		;bestemmer hvor lenge signalet varer
	movwf	xx		;ca 4*hyere enn for brann
f
	bcf	portb,6		
	call	wait
	movlw	B'10011001'	;Hy tone
	movwf	portb
	call 	strobe
	decfsz	xx	
	goto 	f
	btfsc	inng,2
	goto	restart
	goto	tlf2

restart	clrf	portb
	movlw	100		;tid fr ny alarm kan gis etter inngangene
	movwf	xx		;har blitt lave
re	call 	wait
	decfsz	xx
	goto	rest
	decfsz	teller		;sjekker om teller er 0
	goto	start
	goto	summer
rest	btfsc	porta,0
	goto	restart
	btfsc	porta,1
	goto	restart
	goto	re

summer	movlw	60
	movwf	teller
su	clrf	portb		;starter summer etter x antall oppring
	bsf	porta,2		;og lser senderen og m deretter resettes
	movlw	50		;tonehyden p summeren		
	movwf	xx
summ	decfsz	xx
	goto	summ
	bcf	porta,2
	movlw	50		;tonehyde p summeren
	movwf	xx
sum	decfsz	xx
	goto	sum
	decfsz	teller
	goto	su
	movlw	30		;pause tiden til summeren
	movwf	teller
suv	call	wait
	decfsz	teller
	goto	suv
	goto	summer
	

strobe				;prosedyre som laster siffer over i DTMF
	call 	wait		;senderen og sender dette
	bsf	portb,5
	call 	wait
	bcf	portb,5
	bsf	portb,6
	call	wait
	call	wait
	call	wait



; ----------------------------
; wait subroutine 
; ----------------------------
wait    
	movlw   .100	        ; load count1 with decimal 200
	movwf   count1
d1	movlw   .100		; load count2 with decimal 200
	movwf   count2	
				; shorten these for the simulator
	
d2	decfsz  count2,same	; decrement and skip next line if zero
	goto 	d2		; if not zero		
	decfsz  count1		; decrement count1 if count2 is zero
	goto 	d1		; do inside loop again if count2 nz
	retlw 	00
; ----------------------------        
END

